﻿;es fehlt
; bei Move Farben etc mitnehmen

;https://www.dropbox.com/s/srhte1dqh1kmebo/miniadr.chm
;https://www.dropbox.com/sh/5ervlzllesmsd6z/uJeMsbRNnr

;für Purebasic ab 5.1 Vollversion Feb. 2013

;FunktionsReihenfolge ist in der Regel
; 
; MainWindow;   Menu 1-99 ruft im MainEvent() InputEvaluate() auf
; InputEvaluate
; InputWindow
; InputAnalyze mit InputWindowClose

#msg_version = "MiniAdr ab PB 5.1" + #LF$ + "2009/2013 - V.2.01" + #LF$ + "HJBremer"
#buttonbr = 125
#buttonhh = 22
#fieldmax = 14
#googlemap = "http://maps.google.de/maps?saddr=Neumünster,+Germany&daddr=Hamburg"

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
   #RBUTTONDOWN_EVENT = #WM_RBUTTONDOWN
CompilerElse
   #RBUTTONDOWN_EVENT = #PB_Event_RightClick
CompilerEndIf

Enumeration 1
   #window_main: #window_input: #list_nr
   #popup_main: #popup_input
   #menu_01 ;1-99 call InputEvaluate()
   #menu_load: #menu_save: #menu_save2
   #menu_kill: #menu_mark: #menu_nomark: #menu_strgc: #menu_strgv 
   #menu_print: #menu_sort: #menu_move: #menu_uni
   #menu_50 ;50-99 needs InputStringGadgets
   #menu_new: #menu_edit: #menu_cdel: #menu_add
   #menu_ftyp: #menu_word: #menu_calc
   #menu_width: #menu_popup: #menu_head: #menu_align
   #menu_99   
   #menu_searchF3: #menu_searchF4: #menu_searchF5
   #menu_progende: #menu_proginfo: #menu_progdiv1: #menu_proghelp
   #add_all: #add_sel1: #add_sel2: #sort_gk: #sort_up: #sort_dw
   #prn_spin1: #prn_spin2: #prn_spin3: #prn_all: #prn_sel1: #prn_sel2
   #sop_inc: #sop_low: #sop_big: #sop_equ
   #input_box: #input_box1: #input_box2: #input_box3: #input_align
   #input_go: #input_break: #input_clear: #input_return
   #input_date: #input_help: #input_color: #input_replace: #input_rcheck   
   #input_text: #input_line: #input_font: #input_mask1: #input_mask2
   #input_item = 900 ;PopUp Input, to 900 + #fieldmax 
   #lastfiles = 950
EndEnumeration

Structure WindowSize
   x.i
   y.i
   br.i
   hh.i
EndStructure
Structure InputField
   name.s   ;Spaltenname
   br.i     ;Breite in der Liste + Eingabe
   strgnr.i ;PbNr des EingabeStringGadgets 
   textnr.i ;PbNr des EingabeTextGadgets 
   typ.i    ;Feldtyp 48-57=Zahl, 35=#Datum, 84=Text
   align.i
   rg.s     ;für Rechnen
   add.s    ;für Addieren (Summe)
   colorcol.i     ;für jede Spalte
   highcolor.i    ;für Highlight Wörter
   highwords.s    ;
EndStructure

Structure Programmvariablen
   filename.s
   main.WindowSize   ;MainWindowposition + Größe
   input.WindowSize  ;InputWindowposition
   inputmode.i       ;Menuauswahl
   dataset.s         ;letzter geladener, bearbeiteter Datensatz
   searchword.s      ;für Suche im ganzen Datensatz
   searchset.s       ;für Suche in einzelnen Feldern
   searchtyp.i       ;für verschiedene Sucharten
   founditem.i       ;für Suche  
   addoption.i       ;für Inhalte addieren
   lastfocus.i       ; 
   lastdate.i        ;für DateGadget, 
   oldgadgetlist.i   ;da InputWindow zerstört wird, zurück zur vorherigen Gadgetlist
   prnsize.i         ;lupe macht den Druck größer/kleiner
   prnfields.i       ;bis zu welchem Feld wird gedruckt   
   datemask.s 
   linecolor.i
   textcolor.i
   fontname.s
   fontsize.i
   replacetext.s
   replaceflag.i
   lastfilesmax.i
   Array lastfiles.s(0)
   Array sortfieldnr.i(3)      ;nach welchen Feldern wird sortiert
   Array field.InputField(0)  ;enthält Daten für Eingabefelder, wird beim Laden dimensioniert
EndStructure

EnableExplicit                ;alle Variablen müssen deklariert werden

Global prgv.Programmvariablen

Procedure.s DataListGetItem(iitem)
   Protected isubitem, item$ = ""
   For isubitem = 0 To #fieldmax
      item$ + GetGadgetItemText(#list_nr, iitem, isubitem) + #LF$
   Next
   ProcedureReturn item$
EndProcedure

Procedure.i DataListAlign(nr = #PB_Any)
   CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      
      Protected j, lvc.LV_COLUMN 
      
      DisableGadget(#list_nr, 1)
      If nr = #PB_Any
         For j = 1 To #fieldmax
            lvc\mask = #LVCF_FMT 
            lvc\fmt  = prgv\field(j)\align 
            SendMessage_(GadgetID(#list_nr), #LVM_SETCOLUMN, j, lvc) 
         Next
      Else
         lvc\mask = #LVCF_FMT 
         lvc\fmt  = Val(GetGadgetText(prgv\field(nr)\strgnr))
         SendMessage_(GadgetID(#list_nr), #LVM_SETCOLUMN, nr, lvc) 
      EndIf      
      DisableGadget(#list_nr, 0)
      
   CompilerEndIf
EndProcedure
   
Procedure.i DataListColors(iitem = -1)
   With prgv
      Protected j, k, von, bis, item$, subitem$, find$, anz = CountGadgetItems(#list_nr) - 1
      
      ;Liste allgemein
      LoadFont(1, \fontname, \fontsize)
      SetGadgetFont(#list_nr, FontID(1))
      SetGadgetColor(#list_nr, #PB_Gadget_LineColor, \linecolor)
      SetGadgetColor(#list_nr, #PB_Gadget_FrontColor, \textcolor)
      
      ;Column
      For j = 0 To #fieldmax
         SetGadgetItemColor(#list_nr, iitem, #PB_Gadget_BackColor, \field(j)\colorcol, j) 
      Next
            
      ;Rows      
      If iitem = -1
         von = 0: bis = anz
      Else 
         von = iitem: bis = iitem
      EndIf
      For iitem = von To bis
         item$ = DataListGetItem(iitem)
         For j = 1 To #fieldmax
            find$ = \field(j)\highwords
            If find$ = "": Break: EndIf
            For k = 1 To #fieldmax
               subitem$ = GetGadgetItemText(#list_nr, iitem, k)
               If FindString(subitem$, find$, 1, #PB_String_NoCase) 
                  SetGadgetItemColor(#list_nr, iitem, #PB_Gadget_FrontColor, \field(j)\highcolor, k) 
               EndIf
            Next 
         Next
      Next
   EndWith
EndProcedure

Procedure.i ListFileIni(mode$)
   With prgv
      Protected j, br, i$, vg$
      Protected dat$ = \filename + ".ini"        
      Protected iniok = OpenPreferences(dat$)
      
      If iniok = 0: CreatePreferences(dat$): EndIf
      
      If mode$ = "write"      
         PreferenceGroup("Allgemein")
         WritePreferenceInteger("WindowX", \main\x)
         WritePreferenceInteger("WindowY", \main\y)
         WritePreferenceInteger("WindowB", \main\br)
         WritePreferenceInteger("WindowH", \main\hh)
         WritePreferenceInteger("InputX",  \input\x)
         WritePreferenceInteger("InputY",  \input\y) 
         WritePreferenceString ("Datemask", \datemask)
         WritePreferenceString ("Fontname", \fontname)
         WritePreferenceInteger("Fontsize", \fontsize)
         WritePreferenceInteger("LastDate",   \lastdate)
         WritePreferenceInteger("Linecolor",  \linecolor)
         WritePreferenceInteger("Textcolor",  \textcolor)
         WritePreferenceInteger("PrintSize",  \prnsize)
         WritePreferenceInteger("PrintFields", \prnfields)
         PreferenceGroup("Datei")
         For j = 0 To #fieldmax
            br = GetGadgetItemAttribute(#list_nr, 0, #PB_ListIcon_ColumnWidth, j)
            WritePreferenceInteger("Feld " + Str(j), br)
         Next
         For j = 0 To #fieldmax
            WritePreferenceInteger("FarbeSpalte " + Str(j), \field(j)\colorcol)
         Next
         For j = 0 To #fieldmax
            WritePreferenceInteger("FarbeZeile " + Str(j), \field(j)\highcolor)
         Next
         For j = 0 To #fieldmax
            WritePreferenceInteger("Typ " + Str(j), \field(j)\typ)
         Next
         For j = 1 To #fieldmax
            WritePreferenceInteger("Align " + Str(j), \field(j)\align)
         Next
         For j = 1 To #fieldmax
            WritePreferenceString ("Formel " + Str(j), \field(j)\rg)
         Next
         For j = 1 To #fieldmax
            WritePreferenceString ("Wörter " + Str(j), \field(j)\highwords)
         Next
         For j = 1 To #fieldmax
            WritePreferenceString ("Summe " + Str(j), \field(j)\add)
         Next
         For j = 1 To #fieldmax
            i$ = GetMenuItemText(#popup_input, #input_item + j)
            WritePreferenceString ("PopUp " + Str(j), i$)
         Next
         
      ElseIf mode$ = "read"
         PreferenceGroup("Allgemein")
         \main\x    = ReadPreferenceInteger("WindowX", 200)
         \main\y    = ReadPreferenceInteger("WindowY", 100)
         \main\br   = ReadPreferenceInteger("WindowB", 800)
         \main\hh   = ReadPreferenceInteger("WindowH", 500)
         \input\x   = ReadPreferenceInteger("InputX",  300)
         \input\y   = ReadPreferenceInteger("InputY",  300)
         \datemask  = ReadPreferenceString ("Datemask", "%dd.%mm.%yyyy")
         \fontname  = ReadPreferenceString ("Fontname", "Arial")
         \fontsize  = ReadPreferenceInteger("Fontsize", 10)
         \linecolor = ReadPreferenceInteger("Linecolor", $EFEFEF)
         \textcolor = ReadPreferenceInteger("Textcolor", $880000)
         \lastdate  = ReadPreferenceInteger("LastDate", 0)
         \prnsize   = ReadPreferenceInteger("PrintSize", 15)
         \prnfields = ReadPreferenceInteger("PrintFields", 10)
         PreferenceGroup("Datei")
         For j = 0 To #fieldmax
            If j = 0: br = 0: Else: br = 99: EndIf ;Vorgabe für br
            \field(j)\br  = ReadPreferenceInteger("Feld " + Str(j), br)
            \field(j)\typ  = ReadPreferenceInteger("Typ " + Str(j), 84)
            \field(j)\align = ReadPreferenceInteger("Align " + Str(j), 0)
         Next
         For j = 0 To #fieldmax
            \field(j)\colorcol = ReadPreferenceInteger("FarbeSpalte " + Str(j), $DFffff)
         Next
         For j = 0 To #fieldmax
            \field(j)\highcolor = ReadPreferenceInteger("FarbeZeile " + Str(j), $770000)
         Next
         For j = 1 To #fieldmax
            \field(j)\rg  = ReadPreferenceString ("Formel " + Str(j), "")
         Next
         For j = 1 To #fieldmax
            If j = 1: vg$ = "Zusammenfassung": Else: vg$ = "": EndIf 
            \field(j)\highwords = ReadPreferenceString ("Wörter " + Str(j), vg$)
         Next
         For j = 1 To #fieldmax
            \field(j)\add = ReadPreferenceString ("Summe " + Str(j), "")
         Next
         For j = 1 To #fieldmax
            If j = 1: vg$ = "Flohmarkt": Else: vg$ = "": EndIf 
            i$ = ReadPreferenceString ("PopUp " + Str(j), vg$)
            If i$
               SetMenuItemText(#popup_input, #input_item + j, i$)
            EndIf   
         Next   
      EndIf
   EndWith
   ClosePreferences()
EndProcedure

Procedure.i DataListCreate(daten$ = "")
   Protected j, flags
   With prgv      
      flags = #PB_ListIcon_FullRowSelect|#PB_ListIcon_GridLines|#PB_ListIcon_HeaderDragDrop
      flags | #PB_ListIcon_AlwaysShowSelection|#PB_ListIcon_MultiSelect|#PB_ListIcon_CheckBoxes
      If IsGadget(#list_nr): FreeGadget(#list_nr): EndIf      
      ListIconGadget(#list_nr, 0, 0, 0, 0, "", 0, flags)
      HideGadget(#list_nr, 1)    ;für schnelleres Laden/Anzeigen der Liste
      If daten$ = ""
         Restore Data_DemoDaten: Read.s daten$      
         ReplaceString(daten$, "," , #LF$, #PB_String_InPlace)         
      EndIf
      Dim \field(#fieldmax)  
      ListFileIni("read")
      For j = 0 To #fieldmax         
         \field(j)\name = StringField(daten$, j+1, #LF$)
         AddGadgetColumn(#list_nr, j, \field(j)\name, \field(j)\br)
      Next
      DataListAlign()
      ResizeWindow(#window_main, \main\x, \main\y, \main\br, \main\hh)
      ResizeGadget(#list_nr, 0, 0, \main\br, \main\hh - StatusBarHeight(0) - MenuHeight())
   EndWith
   ProcedureReturn 1
EndProcedure

Procedure.i LastFilesUpdateMenu()
   With prgv
      Protected posi, j, menutext$
      
      ;schon vorhanden ?
      posi = \lastfilesmax
      For j = 1 To \lastfilesmax
         If \filename = \lastfiles(j): posi = j: Break: EndIf
      Next
      
      ;schieben
      For j = posi To 2 Step -1
         \lastfiles(j) = \lastfiles(j-1)
      Next
      \lastfiles(1) = \filename
      
      ;UpdateMenu 
      For j = 1 To \lastfilesmax
         menutext$ = Str(j) + ")  " + GetFilePart(\lastfiles(j))
         SetMenuItemText(0, #lastfiles + j, menutext$)
         DisableMenuItem(0, #lastfiles + j, 1)
         If Trim(\lastfiles(j))
            DisableMenuItem(0, #lastfiles + j, 0)
         EndIf 
      Next
   EndWith
EndProcedure

Procedure.s ListFileSelect(flag, dat$ = "")
   Protected file$ = prgv\filename 
   Protected patt$ = "Csv (*.csv)|*.csv|Text (*.txt)|*.txt|Alle Dateien (*.*)|*.*"
   If flag = 0
      file$ = OpenFileRequester("Laden: Datei auswählen oder neuen Namen eingeben", file$, patt$, 0)
   Else
      file$ = SaveFileRequester("Speichern: Datei auswählen oder neuen Namen eingeben", file$, patt$, 0)
   EndIf  
   ProcedureReturn file$
EndProcedure
Procedure.i ListFileLoad(mode = 0)
   Protected file$, daten$, header = #False   
   If mode
      file$ = ListFileSelect(0, prgv\filename)
      If file$ = "": ProcedureReturn: EndIf
      If file$: prgv\filename = file$: EndIf
   EndIf   
   If ReadFile(0, prgv\filename)   
      ;wenn Datei vorhanden
      While Eof(0) = 0          
         daten$ = ReadString(0) 
         ReplaceString(daten$, #TAB$, #LF$, #PB_String_InPlace)
         If header = #False 
            header = DataListCreate(daten$)  ;gibt #true zurück          
         Else
            AddGadgetItem(#list_nr, -1, daten$) 
         EndIf
      Wend
      CloseFile(0)
   Else
      ;wenn Datei Nicht vorhanden   
      DataListCreate()
   EndIf   
   DataListColors()
   HideGadget(#list_nr, 0)
   StatusBarText(0, 0, prgv\filename)
   StatusBarText(0, 1, "")
   LastFilesUpdateMenu()
EndProcedure
Procedure.i ListFileSave(mode = #menu_save)
   Protected file$, item, satz$
   ListFileIni("write")
   If mode = #menu_save2
      file$ = ListFileSelect(1, prgv\filename)
      If file$ = "": ProcedureReturn: EndIf
      If file$: prgv\filename = file$: EndIf
   EndIf
   If GetExtensionPart(prgv\filename) = "": prgv\filename + ".csv": EndIf
   If CreateFile(0, prgv\filename) 
      For item = -1 To CountGadgetItems(#list_nr) - 1 ;incl Header
         satz$ = DataListGetItem(item)
         ReplaceString(satz$, #LF$, #TAB$, #PB_String_InPlace)
         WriteStringN(0, satz$)
      Next   
      CloseFile(0)
      ListFileIni("write")
   EndIf
   StatusBarText(0, 0, prgv\filename + " " + Str(item))
EndProcedure

Procedure.i DataListSort()
   Protected j, k, item$, subitem$
   Protected sortfield, sortoption = 0, itemlg = 30
   Protected dataposi = 1 + (itemlg * 3)
   Protected itemcount = CountGadgetItems(#list_nr) - 1 ;z.B. 9 Daten = 0 - 8
   
   If itemcount < 0: ProcedureReturn: EndIf   
   Dim sort$(3): Dim daten$(itemcount)               ;ab null
   
   prgv\sortfieldnr(1) = GetGadgetState(#input_box1) + 1  ;Listbox beginnt bei null
   prgv\sortfieldnr(2) = GetGadgetState(#input_box2) + 1  ;also ist Spalte 1 hier null
   prgv\sortfieldnr(3) = GetGadgetState(#input_box3) + 1  ;also + 1 in der Liste  
   
   For j = 0 To itemcount 
      item$ = DataListGetItem(j)
      For k = 1 To 3
         sortfield = prgv\sortfieldnr(k)
         subitem$ = StringField(item$, sortfield + 1, #LF$)  ;StringField beginnt bei 1
         Select prgv\field(sortfield)\typ
            Case 35:       subitem$ = Mid(subitem$,7,4) + Mid(subitem$,4,2) + Mid(subitem$,1,2)
                           sort$(k) = LSet(subitem$, itemlg)    ;Datum umgedreht
            Case 48 To 57: sort$(k) = RSet(subitem$, itemlg)    ;Zahl   
            Default:       sort$(k) = LSet(subitem$, itemlg)    ;Text
         EndSelect
      Next
      daten$(j) = sort$(1) + sort$(2) + sort$(3) + item$ ;3 Sortfelder + ganzer Datensatz   
   Next
   
   If GetGadgetState(#sort_gk) = 0: sortoption = #PB_Sort_NoCase: EndIf
   If GetGadgetState(#sort_dw) = 1: sortoption = #PB_Sort_Descending|sortoption: EndIf
   SortArray(daten$(), sortoption)
   
   HideGadget(#list_nr, 1): ClearGadgetItems(#list_nr) 
   For j = 0 To itemcount 
      item$ = Mid(daten$(j), dataposi)   ;die 3 Sortfelder entfernen
      AddGadgetItem(#list_nr,-1, item$)
   Next
   DataListColors()
   HideGadget(#list_nr, 0)
EndProcedure
Procedure.i DataListFieldsAdd()
   Protected nbdec, fnr, lfdnr, newline, ok, msg$, error$
   Protected item$, iitem, isubitem, itemanz = CountGadgetItems(#list_nr) 
   Protected addall = GetGadgetState(#add_all): If addall: prgv\addoption = #add_all: EndIf
   Protected addsel1 = GetGadgetState(#add_sel1): If addsel1: prgv\addoption = #add_sel1: EndIf
   Protected addsel2 = GetGadgetState(#add_sel2): If addsel2: prgv\addoption = #add_sel2: EndIf      
   
   ;Auswertung Eingabe
   Dim add.a(#fieldmax)
   Dim des.i(#fieldmax)
   Dim erg.f(#fieldmax)
   Dim txt.s(#fieldmax)
   
   For isubitem = 1 To #fieldmax      
      item$ = Trim(GetGadgetText(prgv\field(isubitem)\strgnr))
      If Left(item$, 1) = "#"
         add(isubitem) = #True
         fnr = Val(Mid(item$, 2))   ;gibt es eine Feldnummer ?
         If fnr
            des(isubitem) = fnr
         EndIf   
      Else
         txt(isubitem) = item$
      EndIf   
      prgv\field(isubitem)\add = item$  ;Eingaben merken
   Next
   
   ;Summieren
   For iitem = 0 To itemanz - 1
      ok = 0
      If addall: ok = 1
      ElseIf Bool(addsel1 And GetGadgetItemState(#list_nr, iitem) & #PB_ListIcon_Selected): ok = 1
      ElseIf Bool(addsel2 And GetGadgetItemState(#list_nr, iitem) & #PB_ListIcon_Checked): ok = 1
      EndIf   
      If ok: lfdnr + 1
         For isubitem = 1 To #fieldmax
            If add(isubitem) = #True  
               item$ = GetGadgetItemText(#list_nr, iitem, isubitem)
               If FindString(item$, ","): ReplaceString(item$, "," , "." , #PB_String_InPlace): EndIf
               erg(isubitem) + ValF(item$)
            EndIf
         Next
      EndIf               
   Next 
   
   ;Ausgabe
   msg$ = "Summe für " + Str(lfdnr) + " Datensätze" + #LF$ + #LF$
   For isubitem = 1 To #fieldmax
      If add(isubitem) = #True
         Select prgv\field(isubitem)\typ
            Case 48 To 57
               nbdec = prgv\field(isubitem)\typ - 48
               msg$ + #TAB$ + StrF(erg(isubitem), nbdec) + #TAB$ + prgv\field(isubitem)\name + #TAB$
               msg$ + Chr(0248) + " " + StrF(erg(isubitem) / lfdnr, nbdec) + #LF$
               If des(isubitem)
                  iitem = GetGadgetState(#list_nr): If iitem = -1: iitem = 0: EndIf
                  newline = #True
               EndIf   
            Default: error$ + prgv\field(isubitem)\name + ", "
         EndSelect
      EndIf            
   Next
   If error$: msg$ + #LF$ + #LF$ + "Kein Zahlenfeld: " + error$: EndIf
   MessageRequester("Summe", msg$)
   If newline = #True
      AddGadgetItem(#list_nr, iitem, "")
      For isubitem = 1 To #fieldmax
         If des(isubitem)
            SetGadgetItemText(#list_nr, iitem, StrF(erg(isubitem), nbdec), isubitem)
         Else
            SetGadgetItemText(#list_nr, iitem, txt(isubitem), isubitem)
         EndIf
      Next 
      DataListColors(iitem)
   EndIf   
   
EndProcedure

Procedure.i DataListMoveCols()
   Protected j, k
   Protected anz = CountGadgetItems(#list_nr) - 1
   
   Dim newtext.s(#fieldmax)
   Dim oldtext.s(#fieldmax)
   Dim oldtyp.i(#fieldmax)
   Dim oldbr.i(#fieldmax)
   Dim newcol.i(#fieldmax)
   
   For j = 1 To #fieldmax
      newcol(j) = GetGadgetItemData(#input_box, j-1) :Debug newcol(j)
   Next
   
   For j = -1 To anz      
      For k = 1 To #fieldmax
         oldtext(k) = GetGadgetItemText(#list_nr, j, k) 
      Next      
      For k = 1 To #fieldmax
         SetGadgetItemText(#list_nr, j, oldtext(newcol(k)), k)
      Next      
   Next   
   
   For k = 1 To #fieldmax
      oldtext(k) = prgv\field(k)\name      
      oldtyp(k) = prgv\field(k)\typ      
      oldbr(k) = prgv\field(k)\br      
   Next
   
   For k = 1 To #fieldmax
      prgv\field(k)\name = oldtext(newcol(k))  
      prgv\field(k)\typ = oldtyp(newcol(k))  
      prgv\field(k)\br = oldbr(newcol(k))  
   Next
   
   For k = 1 To #fieldmax
      SetGadgetItemAttribute(#list_nr, 0, #PB_ListIcon_ColumnWidth, prgv\field(k)\br, k)
   Next
   
   ListFileIni("write")
   ListFileSave()
         
EndProcedure

Macro DataSearchCompare(expression)
   
   If expression 
      ok = #True
   Else
      ok = -1
   EndIf    
   
EndMacro

Procedure.i DataSearchStringField(satz$)
   Protected isubitem, ok = -1, itemlg = 30
   Protected subitem$, suchitem$, mode = #PB_String_NoCase ;#PB_String_CaseSensitive   
   
   ;alle Eingaben müssen zutreffen !
   
   For isubitem = 1 To #fieldmax  
      subitem$ = StringField(satz$, isubitem + 1, #LF$)  
      suchitem$ = StringField(prgv\searchset, isubitem + 1, #LF$)  
      If suchitem$
         Select prgv\searchtyp  ;wird in InputAnalyze() gesetzt
            Case 3, 4         ;nur bei Datum und Zahlen item$ umwandeln               
               Select prgv\field(isubitem)\typ
                  Case 35        ;Datum
                  Case 48 To 57  ;Zahlen
                     subitem$ = RSet(subitem$, itemlg)
                     suchitem$ = RSet(suchitem$, itemlg)
               EndSelect
         EndSelect                  
         Select prgv\searchtyp
            Case 1: DataSearchCompare(FindString(subitem$, suchitem$, 1, mode));enthalten   
            Case 2: DataSearchCompare(subitem$ = suchitem$)                    ;gleich
            Case 3: DataSearchCompare(subitem$ < suchitem$)                    ;kleiner
            Case 4: DataSearchCompare(subitem$ > suchitem$)                    ;größer
         EndSelect
         If ok = -1: Break: EndIf
      EndIf
   Next
   
   ProcedureReturn ok    
EndProcedure

Procedure.i DataSearchReplace(satz$, iitem)
   Protected isubitem
   Protected subitem$, suchitem$, mode = #PB_String_NoCase ;#PB_String_CaseSensitive   
   
   For isubitem = 1 To #fieldmax  
      subitem$ = StringField(satz$, isubitem + 1, #LF$)  
      suchitem$ = StringField(prgv\searchset, isubitem + 1, #LF$)  
      If suchitem$
         If FindString(subitem$, suchitem$, 1, mode)
            subitem$ = ReplaceString(subitem$, suchitem$, prgv\replacetext, mode)
            SetGadgetItemText(#list_nr, iitem, subitem$, isubitem)
         EndIf    
      EndIf
   Next
   
EndProcedure

Procedure.i DataSearch(abitem = 0)
   Protected iitem, item$, msg, ok = #False   
   
   For iitem = abitem To CountGadgetItems(#list_nr) - 1
      item$ = DataListGetItem(iitem)
      If prgv\inputmode = #menu_searchF4
         If FindString(item$, prgv\searchword, 1, #PB_String_NoCase)
            ok = #True: prgv\founditem = iitem: Break    
         EndIf
      ElseIf prgv\inputmode = #menu_searchF5          
         If DataSearchStringField(item$) = #True
            ok = #True: prgv\founditem = iitem: Break
         EndIf
      EndIf      
   Next   
   
   If ok = #True
      SetGadgetState(#list_nr, iitem)
      SetActiveGadget(#list_nr)
      If Bool(prgv\replaceflag And prgv\inputmode = #menu_searchF5)
         msg = MessageRequester("Info", "Ersetzen durch " + prgv\replacetext, #PB_MessageRequester_YesNoCancel) 
         Select msg
            Case #PB_MessageRequester_Yes
               DataSearchReplace(item$, iitem)
               PostEvent(#PB_Event_Menu, #window_main, #menu_searchF3)
            Case #PB_MessageRequester_No
               PostEvent(#PB_Event_Menu, #window_main, #menu_searchF3)
            Case #PB_MessageRequester_Cancel
               ;tue nix
         EndSelect
      EndIf   
   EndIf   
   
   ProcedureReturn ok
EndProcedure
Procedure.i DataSearchNext()   
   weitersuchen:
   If DataSearch(prgv\founditem + 1) = #False
      Protected info$ = "Keine Daten gefunden!" + #LF$ + #LF$ + "von Beginn an weitersuchen ?"
      If MessageRequester("Information", info$, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
         prgv\founditem = -1
         Goto weitersuchen ;dies ist ein locales Label und ist die einfachste Lösung der Schleife
      EndIf
   EndIf   
EndProcedure

Procedure.i PrintListRow(item, x, y, faktor.f)   
   Protected item$ = DataListGetItem(item)
   Protected isubitem, subitem$, br, leftmargin = x
   For isubitem = 1 To prgv\prnfields  
      subitem$ = StringField(item$, isubitem + 1, #LF$)                  
      DrawText(x, y, subitem$, #Black, #White)                  
      br + GetGadgetItemAttribute(#list_nr, 0, #PB_ListIcon_ColumnWidth, isubitem)
      x = leftmargin + (br * faktor)                  
   Next   
EndProcedure
Procedure.i PrintList()
   Protected deskwidth, pagewidth, pageheight
   Protected linespacing, leftmargin, topmargin, x, y
   Protected faktor.f, dpmm.f, lupe.f = prgv\prnsize / 10
   Protected copies, itempropage, iitem, lfdnr
   Protected fontbold, fontnormal, headline, infowidth, infoposx, infoposy, infonr
   Protected prnall = GetGadgetState(#prn_all)
   Protected prnsel = GetGadgetState(#prn_sel1)
   Protected itemanz = CountGadgetItems(#list_nr) - 1
   
   If Bool(prnall = 0 And prnsel = 0): prnsel = 2: EndIf
   
   If DefaultPrinter()
      ExamineDesktops()
      deskwidth = DesktopWidth(0)   
      pagewidth = PrinterPageWidth()
      pageheight = PrinterPageHeight()      
      If pagewidth < pageheight  ;Normal A4
         faktor = (pagewidth / deskwidth) * lupe: dpmm = pagewidth / 210   ;210mm A4 = Dots pro mm
      Else                       ;Querformat A4
         faktor = (pageheight / deskwidth) * lupe: dpmm = pageheight / 210   
      EndIf      
      fontbold = LoadFont(#PB_Any, "Arial", 10 * faktor, #PB_Font_Bold)
      fontnormal = LoadFont(#PB_Any, "Arial", 10 * faktor)

      If StartDrawing(PrinterOutput())
         DrawingFont(FontID(fontbold))
         linespacing = TextHeight("X") + 5
         infowidth = TextWidth("Seite 123")
         StopDrawing()
      EndIf      
      topmargin = 10 * dpmm   ;ca 10 mm für Linker und oberer Rand, Seiteninfo zählt nicht
      leftmargin = 11 * dpmm
      infoposx = pagewidth - infowidth: infoposy = topmargin - linespacing - 5
      itempropage = (pageheight - topmargin - topmargin - linespacing) / linespacing
      
      For copies = 1 To GetGadgetState(#prn_spin3)    ;Liste wie oft drucken
         x = leftmargin: y = topmargin
         lfdnr = 0: infonr = 0: headline = #True  
         If StartPrinting("Miniadr" + Str(copies))
            If StartDrawing(PrinterOutput())
               For iitem = 0 To itemanz
                  If headline = #True   ;Listen-Überschrift drucken
                     headline = #False
                     DrawingFont(FontID(fontnormal)): infonr + 1
                     DrawText(infoposx, infoposy, "Seite " + Str(infonr), #Black, #White)
                     DrawingFont(FontID(fontbold))
                     PrintListRow(-1, x, y, faktor): y + linespacing  ;Header
                  EndIf 
                  DrawingFont(FontID(fontnormal))                  
                  If prnall
                     PrintListRow(iitem, x, y, faktor): y + linespacing: lfdnr + 1
                  ElseIf prnsel = 1
                     If GetGadgetItemState(#list_nr, iitem) & #PB_ListIcon_Selected
                        PrintListRow(iitem, x, y, faktor): y + linespacing: lfdnr + 1
                     EndIf
                  ElseIf prnsel = 2
                     If GetGadgetItemState(#list_nr, iitem) & #PB_ListIcon_Checked
                        PrintListRow(iitem, x, y, faktor): y + linespacing: lfdnr + 1
                     EndIf
                  EndIf                  
                  If Mod(lfdnr, itempropage) = itempropage - 1 ; minus 1, weil lfdnr ab null
                     headline = #True: y = topmargin           ; lfdnr % itempropage geht auch
                     NewPrinterPage()
                  EndIf   
               Next iitem
               StopDrawing()
            EndIf         
            StopPrinting()
         EndIf
      Next copies
      FreeFont(fontbold): FreeFont(fontnormal)
   EndIf
EndProcedure

Procedure.i InputWindow(info$, dataset$ = "")
   With prgv      
      Protected flags = #PB_Window_Tool|#PB_Window_SystemMenu|#PB_Window_Invisible|#PB_Window_NoGadgets      
      
      \input\br = 450 
      \input\hh = 60 + (#fieldmax * (#buttonhh + 5))
      
      OpenWindow(#window_input, \input\x, \input\y, \input\br, \input\hh, info$, flags, WindowID(#window_main)) 
      \oldgadgetlist = UseGadgetList(WindowID(#window_input))  ;!!!      
      \lastfocus = 1 ;zur Sicherheit auf 1 setzen
      
      Protected j, i$, v$, br = 60
      Protected x , y = 15
      Protected x1 = 10, x2 = x1 + br + 5, x3
      Protected textbr, strgbr, strgbrmax = \input\br - x1 - 25 - #buttonbr - br
    
      Select \inputmode
         Case #menu_50 To #menu_99, #menu_searchF5
            For j = 1 To #fieldmax    
               strgbr = GetGadgetItemAttribute(#list_nr, 0, #PB_ListIcon_ColumnWidth, j)
               textbr = br
               \field(j)\br = strgbr
               If strgbr > strgbrmax: strgbr = strgbrmax: EndIf
               i$ = \field(j)\name
               v$ = StringField(dataset$, j + 1, #LF$)
               Select \inputmode
                  Case #menu_ftyp, #menu_cdel, #menu_align: strgbr = 120
                  Case #menu_head:  If strgbr = 0: strgbr = br: EndIf
                  Case #menu_width: If strgbr = 0: strgbr = br: EndIf: v$ = Str(\field(j)\br)
                  Case #menu_calc:  strgbr = 120: i$ = Str(j): v$ = \field(j)\rg
                  Case #menu_word:  strgbr = 150: i$ = Str(j): v$ = \field(j)\highwords
                  Case #menu_popup: strgbr = 150: i$ = Str(j): v$ = GetMenuItemText(#popup_input, #input_item + j)
               EndSelect
               If strgbr = 0: textbr = 0: EndIf
               \field(j)\textnr = TextGadget  (#PB_Any, x1, y + 5, textbr, #buttonhh, i$, #PB_Text_Right)
               \field(j)\strgnr = StringGadget(#PB_Any, x2, y + 0, strgbr, #buttonhh, v$)
               Select \inputmode
                  Case #menu_calc, #menu_popup ;keine Farben
                  Case #menu_word: SetGadgetColor(\field(j)\strgnr, #PB_Gadget_FrontColor, \field(j)\highcolor)
                  Case #menu_head: SetGadgetColor(\field(j)\strgnr, #PB_Gadget_BackColor, \field(j)\colorcol)
                  Default
                     Select prgv\field(j)\typ
                        Case 48 To 57: SetGadgetColor(prgv\field(j)\textnr, #PB_Gadget_FrontColor, $007722)
                        Case 35:       SetGadgetColor(prgv\field(j)\textnr, #PB_Gadget_FrontColor, $7c0000)
                        Default:       SetGadgetColor(prgv\field(j)\textnr, #PB_Gadget_FrontColor, 0)   
                     EndSelect
               EndSelect
               If strgbr: y + #buttonhh + 5: EndIf
            Next
            SetActiveGadget(\field(1)\strgnr)
            AddKeyboardShortcut(#window_input, #PB_Shortcut_Return, #input_return)
      EndSelect
      
      Select \inputmode
         Case #menu_uni: info$ = "ok"
         Case #menu_new: info$ = "&Daten Hinzufügen"
         Case #menu_cdel: info$ = "&Daten löschen"
         Case #menu_print: info$ = "&Drucken"
         Case #menu_searchF5: info$ = "&Suche starten"
         Case #menu_add, #menu_sort: info$ = "&Start"  
         Case #menu_head, #menu_edit, #menu_move: info$ = "&Daten Ändern"
         Case #menu_calc, #menu_ftyp, #menu_popup: info$ = "&Speichern"
         Case #menu_width, #menu_word, #menu_align: info$ = "&Speichern"
      EndSelect
      
      y = \input\hh - 10 - #buttonhh
      x1 = 10
      x2 = \input\br / 2  
      x3 = WindowWidth(#window_input) - #buttonbr - 10
      
      ButtonGadget(#input_go, x1, y, #buttonbr, #buttonhh, info$) 
      ButtonGadget(#input_break, x3, y, #buttonbr, #buttonhh, "&Abbruch")      
      AddKeyboardShortcut(#window_input, #PB_Shortcut_Alt|#PB_Shortcut_D, #input_go)
      AddKeyboardShortcut(#window_input, #PB_Shortcut_Alt|#PB_Shortcut_S, #input_go)
      AddKeyboardShortcut(#window_input, #PB_Shortcut_Alt|#PB_Shortcut_A, #input_break)
      AddKeyboardShortcut(#window_input, #PB_Shortcut_Escape,             #input_break)
      AddKeyboardShortcut(#window_input, #PB_Shortcut_F1,                 #input_help)
      
      y = 15      
      Select \inputmode
            
         Case #menu_uni
            TextGadget(#PB_Any, x1, y, #buttonbr, #buttonhh, "Liste:"): y + #buttonhh 
            OptionGadget(#input_text, x1, y, #buttonbr, #buttonhh, "Textfarbe"): y + #buttonhh
            OptionGadget(#input_line, x1, y, #buttonbr, #buttonhh, "Gitterfarbe"): y + #buttonhh
            OptionGadget(#input_font, x1, y, #buttonbr, #buttonhh, "Listenfont"): y + #buttonhh + 10
            y = 15
            TextGadget(#PB_Any, x2, y, #buttonbr, #buttonhh, "Datumsformat:"): y + #buttonhh 
            OptionGadget(#input_mask1, x2, y, #buttonbr, #buttonhh, "30.12.12"): y + #buttonhh
            OptionGadget(#input_mask2, x2, y, #buttonbr, #buttonhh, "30.12.2012"): y + #buttonhh + 10
            SetGadgetState(#input_mask1, 1)
            If \datemask = "%dd.%mm.%yyyy": SetGadgetState(#input_mask2, 1): EndIf
            
         Case #menu_align
            info$ = "Ausrichtung:" + #LF$ + #LF$
            info$ + "  0 = Links" + #LF$ + #LF$
            info$ + "  1 = Rechts" + #LF$ + #LF$
            info$ + "  2 = Mitte"
            TextGadget(#PB_Any, x2, y, #buttonbr, 150, info$)
            
         Case #menu_edit, #menu_new
            ButtonGadget(#input_clear, x3, y, #buttonbr, #buttonhh, "Eingaben &Löschen") :y + #buttonhh + 10
            AddKeyboardShortcut(#window_input, #PB_Shortcut_Alt|#PB_Shortcut_L, #input_clear)
            DateGadget(#input_date, x3, y, #buttonbr, #buttonhh, \datemask, \lastdate)
            
         Case #menu_searchF5
            ButtonGadget(#input_clear, x3, y, #buttonbr, #buttonhh, "Eingaben &Löschen"): y + #buttonhh + 10      
            AddKeyboardShortcut(#window_input, #PB_Shortcut_Alt|#PB_Shortcut_L, #input_clear)
            CheckBoxGadget(#input_rcheck, x3, y, #buttonbr, #buttonhh, "Ersetzen"): y + #buttonhh 
            StringGadget(#input_replace, x3, y, #buttonbr, #buttonhh, \replacetext): y + #buttonhh + 10
            DisableGadget(#input_replace, 1)
            TextGadget(#PB_Any, x3, y, #buttonbr, #buttonhh, "Suchbegriff ist:"):y + #buttonhh 
            OptionGadget(#sop_inc, x3, y, #buttonbr, #buttonhh, " enthalten"):   y + #buttonhh 
            OptionGadget(#sop_equ, x3, y, #buttonbr, #buttonhh, " gleich"):      y + #buttonhh 
            OptionGadget(#sop_low, x3, y, #buttonbr, #buttonhh, " kleiner"):     y + #buttonhh 
            OptionGadget(#sop_big, x3, y, #buttonbr, #buttonhh, " größer"):      y + #buttonhh
            SetGadgetState(#sop_inc, 1)            
            
         Case #menu_word, #menu_head
            ButtonGadget(#input_clear, x3, y, #buttonbr, #buttonhh, "Eingaben &Löschen"): : y + #buttonhh + 10      
            AddKeyboardShortcut(#window_input, #PB_Shortcut_Alt|#PB_Shortcut_L, #input_clear)
            ButtonGadget(#input_color, x3, y, #buttonbr, #buttonhh, "Farbauswahl")      
            
         Case #menu_add
            ButtonGadget(#input_clear, x3, y, #buttonbr, #buttonhh, "Eingaben &Löschen"): y + #buttonhh + 10
            AddKeyboardShortcut(#window_input, #PB_Shortcut_Alt|#PB_Shortcut_L, #input_clear)
            DateGadget(#input_date, x3, y, #buttonbr, #buttonhh, \datemask, \lastdate): y + #buttonhh + 10
            OptionGadget(#add_all,  x3, y, #buttonbr, #buttonhh, " Alle Daten"): y + #buttonhh 
            OptionGadget(#add_sel1, x3, y, #buttonbr, #buttonhh, " nur Markierung"): y + #buttonhh 
            OptionGadget(#add_sel2, x3, y, #buttonbr, #buttonhh, " nur Checkboxen"): y + #buttonhh + 10
            SetGadgetState(#add_sel1, 1)
            If \addoption: SetGadgetState(\addoption, 1): EndIf
            info$ = "Nur Zahlenfelder in dem ein # steht werden addiert."
            TextGadget(#PB_Any, x3, y, #buttonbr, 150, info$)
            
         Case #menu_calc
            info$ = "z.B." + #LF$ + #LF$
            info$ + "7=#5/#4" + #LF$ + #LF$
            info$ + "8= #6 / 100" + #LF$ + #LF$
            info$ + "9 = #6 * 1.19" + #LF$ + #LF$
            info$ + "0 = #1 + #2" + #LF$
            info$ + "4 = #0 + #3"
            TextGadget(#PB_Any, x2, y, #buttonbr, 150, info$)
            ListViewGadget(#input_box, x3, y, #buttonbr, 250)
            For j = 1 To #fieldmax
               AddGadgetItem (#input_box, -1, Str(j) + "  " + prgv\field(j)\name)
            Next 
            DisableGadget(#input_box, 1)
            
         Case #menu_cdel
            info$ = "Sie müssen ja in ein Feld eingeben, um die Daten der zugehörigen Spalte zu löschen"
            TextGadget(#PB_Any, x2, y, #buttonbr + 50, 150, info$)
            
         Case #menu_ftyp
            info$ = "T = Text" + #LF$
            info$ + "# = Datum" + #LF$ + #LF$
            info$ + "0 = Ganzzahl" + #LF$
            info$ + "1 - 9 = Zahl mit n Dezimalstellen" + #LF$
            TextGadget(#PB_Any, x2, y, #buttonbr + 50, 150, info$)
            
         Case #menu_move
            x = 10: br = (\input\br - 30) / 3
            TextGadget(#PB_Any, x, 10, 300, #buttonhh, "Reihenfolge via Drag Drop ändern")
            ListViewGadget(#input_box,  x, 40, br, 250): x + br + 5
            For j = 1 To #fieldmax
               AddGadgetItem (#input_box, -1, prgv\field(j)\name)
               SetGadgetItemData(#input_box, j-1, j)
            Next 
            EnableGadgetDrop(#input_box, #PB_Drop_Text, #PB_Drag_Copy)
            
         Case #menu_sort
            x = 10: br = (\input\br - 30) / 3
            TextGadget(#PB_Any, x, 10, 300, #buttonhh, "Wählen Sie die Sortierreihenfolge")
            ListViewGadget(#input_box1,  x, 40, br, 250): x + br + 5
            ListViewGadget(#input_box2,  x, 40, br, 250): x + br + 5
            ListViewGadget(#input_box3,  x, 40, br, 250)
            For j = 1 To #fieldmax
               AddGadgetItem (#input_box1, -1, prgv\field(j)\name)   
               AddGadgetItem (#input_box2, -1, prgv\field(j)\name)   
               AddGadgetItem (#input_box3, -1, prgv\field(j)\name)   
            Next
            x = 10
            OptionGadget  (#sort_up, x, 300, #buttonbr, #buttonhh, "aufsteigend")
            OptionGadget  (#sort_dw, x, 325, #buttonbr, #buttonhh, "absteigend")
            SetGadgetState(#sort_up, 1)   
            x + #buttonbr 
            CheckBoxGadget(#sort_gk, x, 300, #buttonbr, #buttonhh, "Groß/Kleinschrift")
            SetGadgetState(#input_box1, prgv\sortfieldnr(1)-1)
            SetGadgetState(#input_box2, prgv\sortfieldnr(2)-1)
            SetGadgetState(#input_box3, prgv\sortfieldnr(3)-1)   
            
         Case #menu_print
            x = 25: y = 15
            OptionGadget(#prn_all,  x, y, #buttonbr, #buttonhh, "alles drucken"): y + #buttonhh + 10
            OptionGadget(#prn_sel1, x, y, #buttonbr, #buttonhh, "Markierung"): y + #buttonhh + 10
            OptionGadget(#prn_sel2, x, y, #buttonbr, #buttonhh, "Checkbox")
            x = 190: y = 15
            SpinGadget(#prn_spin1, x, y, 40, #buttonhh, 10, 25, #PB_Spin_Numeric|#PB_Spin_ReadOnly): y + #buttonhh + 10
            SpinGadget(#prn_spin2, x, y, 40, #buttonhh,  1, 99, #PB_Spin_Numeric|#PB_Spin_ReadOnly): y + #buttonhh + 10
            SpinGadget(#prn_spin3, x, y, 40, #buttonhh,  1, 99, #PB_Spin_Numeric|#PB_Spin_ReadOnly): y + #buttonhh + 10
            x + 5 + 40: y = 15 + 3
            TextGadget(#PB_Any, x, y, #buttonbr, #buttonhh, "größer/kleiner"): y + #buttonhh + 10
            TextGadget(#PB_Any, x, y, #buttonbr, #buttonhh, "Felder drucken"): y + #buttonhh + 10
            TextGadget(#PB_Any, x, y, #buttonbr, #buttonhh, "Anzahl Kopien "): y + #buttonhh + 10
            SetGadgetState(#prn_all, 1)
            SetGadgetState(#prn_spin1, prgv\prnsize)
            SetGadgetState(#prn_spin2, prgv\prnfields)
            SetGadgetState(#prn_spin3, 1)
            
      EndSelect
      DisableWindow(#window_main, 1)
      HideWindow(#window_input, 0)
   EndWith
EndProcedure

Procedure.i InputWindowClose()
   CloseWindow(#window_input)
   DisableWindow(#window_main, 0)
   SetActiveGadget(#list_nr)
   UseGadgetList(prgv\oldgadgetlist)
EndProcedure

Procedure.i InputEvaluate(menupoint)
   With prgv
      Protected j, item$, set$
      Protected iitem = GetGadgetState(#list_nr)   
      Protected count = CountGadgetItems(#list_nr) - 1
      
      \inputmode = menupoint
      
      Select menupoint
         Case #menu_load:  ListFileLoad(1)
         Case #menu_save:  ListFileSave()
         Case #menu_save2: ListFileSave(menupoint)                  
         Case #menu_sort:  InputWindow("Sortieren")
         Case #menu_calc:  InputWindow("Formeln")
         Case #menu_move:  InputWindow("Spalten verschieben")
         Case #menu_print: InputWindow("Drucken")
         Case #menu_popup: InputWindow("PopUp Texte")
         Case #menu_width: InputWindow("Spaltenbreite") 
         Case #menu_uni:   InputWindow("Allgemein")
         Case #menu_cdel:  InputWindow("Spalte löschen")
         Case #menu_searchF5: InputWindow("Suchen", prgv\searchset)         
            
         Case #menu_searchF4
            \searchword = InputRequester("Suchen enthalten", "Suchbegriff: ", \searchword)
            If \searchword 
               If DataSearch() = #False
                  MessageRequester("Information", "Keine Daten gefunden!")
               EndIf
            EndIf         
            
         Case #menu_strgc
            For iitem = 0 To count
               If GetGadgetItemState(#list_nr, iitem) 
                  item$ + DataListGetItem(iitem) + #CR$
               EndIf
            Next
            ReplaceString(item$, #LF$, #TAB$, #PB_String_InPlace)
            SetClipboardText(item$)
                        
         Case #menu_strgv
            set$ = GetClipboardText()
            count = CountString(set$, #CR$)
            For j = 1 To count
               item$ = StringField(set$, j, #CR$)
               ReplaceString(item$, #TAB$, #LF$, #PB_String_InPlace)
               AddGadgetItem(#list_nr, iitem, item$)
               DatalistColors(iitem)
               iitem + 1
            Next
            
         Case #menu_add
            item$ = #LF$
            For j = 1 To #fieldmax
               item$ + \field(j)\add + #LF$
            Next         
            InputWindow("Summe", item$) 
            
         Case #menu_align
            item$ = #LF$
            For j = 1 To #fieldmax
               item$ + Str(\field(j)\align) + #LF$
            Next         
            InputWindow("Ausrichtung", item$) 
            
         Case #menu_word
            item$ = #LF$
            For j = 1 To #fieldmax
               item$ + \field(j)\highwords + #LF$
            Next         
            InputWindow("Wörter", item$)
            
         Case #menu_ftyp
            item$ = #LF$
            For j = 1 To #fieldmax
               item$ + Chr(\field(j)\typ) + #LF$
            Next         
            InputWindow("Feldtyp", item$)
            
         Case #menu_head
            item$ = DataListGetItem(-1)
            InputWindow("Titel + Farben", item$)
            
         Case #menu_mark 
            For iitem = 0 To count
               SetGadgetItemState(#list_nr, iitem, #PB_ListIcon_Selected)
            Next
            
         Case #menu_nomark 
            For iitem = 0 To count
               SetGadgetItemState(#list_nr, iitem, 0)
            Next
            
         Case #menu_new
            If iitem = -1
               \dataset = ""
            Else
               \dataset = DataListGetItem(iitem)
            EndIf
            InputWindow("Neu", \dataset)
            
         Case #menu_edit         
            If iitem > -1
               \dataset = DataListGetItem(iitem)
               InputWindow("Ändern", prgv\dataset)
            Else
               MessageRequester("Information", "Keine Daten markiert!") 
            EndIf
            
         Case #menu_kill         
            If iitem > -1
               j = MessageRequester("Löschen", "markierte Daten löschen ?", #PB_MessageRequester_YesNo) 
               If j = #PB_MessageRequester_Yes
                  DisableGadget(#list_nr, 1)
                  While GetGadgetState(#list_nr) > -1
                     iitem = GetGadgetState(#list_nr)
                     RemoveGadgetItem(#list_nr, iitem)
                  Wend   
                  SetGadgetState(#list_nr, iitem - 1)
                  DisableGadget(#list_nr, 0)
                  SetActiveGadget(#list_nr)
                  If iitem - 1 < 0: SetGadgetState(#list_nr, iitem): EndIf
               EndIf
            Else
               MessageRequester("Information", "Keine Daten markiert!") 
            EndIf
      EndSelect
   EndWith
EndProcedure

Procedure.i InputAnalyze()
   With prgv
      
      Protected j, isubitem, item$, iitem = GetGadgetState(#list_nr)
      
      Select \inputmode ;wird in InputEvaluate() gesetzt 
            
         Case #menu_print
            \prnsize = GetGadgetState(#prn_spin1)
            \prnfields = GetGadgetState(#prn_spin2)   
            SetGadgetText(#input_go, "Druck startet")
            PrintList()
            InputWindowClose()
            
         Case #menu_cdel
            For isubitem = #fieldmax To 1 Step -1
               item$ = Trim(GetGadgetText(\field(isubitem)\strgnr))
               If item$ = "ja"
                  item$ = GetGadgetItemText(#list_nr, -1, isubitem)
                  RemoveGadgetColumn(#list_nr, isubitem)
                  AddGadgetColumn(#list_nr, isubitem, item$, \field(isubitem)\br)
               EndIf   
            Next       
            InputWindowClose() 
            
         Case #menu_uni: InputWindowClose()
         Case #menu_width: InputWindowClose() 
            
         Case #menu_sort
            DataListSort()
            InputWindowClose()
            
         Case #menu_align
            For isubitem = 1 To #fieldmax
               j = Val(GetGadgetText(\field(isubitem)\strgnr))
               Select j
                  Case 1, 2: \field(isubitem)\align = j
                  Default: \field(isubitem)\align = 0
               EndSelect      
            Next
            DataListAlign()
            InputWindowClose()
            
         Case #menu_add
            DataListFieldsAdd()
            InputWindowClose()
            
         Case #menu_word
            For isubitem = 1 To #fieldmax
               item$ = Trim(GetGadgetText(\field(isubitem)\strgnr))
               \field(isubitem)\highwords = item$
               \field(isubitem)\highcolor = GetGadgetColor(\field(isubitem)\strgnr, #PB_Gadget_FrontColor)
            Next
            DataListColors()
            InputWindowClose()
            
         Case #menu_head
            For isubitem = 1 To #fieldmax
               item$ = GetGadgetText(\field(isubitem)\strgnr)
               SetGadgetItemText(#list_nr, -1, item$, isubitem)
               \field(isubitem)\name = item$
               \field(isubitem)\colorcol = GetGadgetColor(\field(isubitem)\strgnr, #PB_Gadget_BackColor)
            Next
            DataListColors()
            InputWindowClose()
            
         Case #menu_popup
            For isubitem = 1 To #fieldmax
               item$ = Trim(GetGadgetText(\field(isubitem)\strgnr))
               SetMenuItemText(#popup_input, #input_item + isubitem, item$)
            Next
            InputWindowClose()
            
         Case #menu_move
            DataListMoveCols()
            InputWindowClose()
            
         Case #menu_searchF5     ;Suchen in Feldern            
            If GetGadgetState(#sop_inc): \searchtyp = 1: EndIf
            If GetGadgetState(#sop_equ): \searchtyp = 2: EndIf
            If GetGadgetState(#sop_low): \searchtyp = 3: EndIf
            If GetGadgetState(#sop_big): \searchtyp = 4: EndIf
            \searchset = #LF$     ;dieses #LF$ steht für Feld null
            For isubitem = 1 To #fieldmax
               item$ = GetGadgetText(\field(isubitem)\strgnr)
               \searchset + item$ + #LF$
            Next
            \replacetext = GetGadgetText(#input_replace)
            If GetGadgetState(#input_rcheck)
               \replaceflag = #True
            Else
               \replaceflag = #False
            EndIf
            InputWindowClose()
            If DataSearch() = #False: MessageRequester("Information", "Keine Daten gefunden!"): EndIf  
            
         Case #menu_new  ;Neuen Satz oben hinzufügen
            \dataset = #LF$ 
            For isubitem = 1 To #fieldmax
               item$ = GetGadgetText(\field(isubitem)\strgnr): \dataset + item$ + #LF$
            Next
            AddGadgetItem(#list_nr, 0, \dataset)
            DataListColors(0)
            SetGadgetState(#list_nr, 0)
            SetActiveGadget(\field(1)\strgnr)
            
         Case #menu_calc
            For j = 1 To #fieldmax
               \field(j)\rg = Trim(GetGadgetText(\field(j)\strgnr))
            Next
            InputWindowClose()
            
         Case #menu_ftyp
            For isubitem = 1 To #fieldmax
               item$ = UCase(Trim(GetGadgetText(\field(isubitem)\strgnr)))
               Select Asc(item$)
                  Case 35, 48 To 57    ; #,0-9
                  Default: item$ = "T"
               EndSelect
               \field(isubitem)\typ = Asc(item$)
            Next
            InputWindowClose()
            
         Case #menu_edit   ;Ändern
            For isubitem = 1 To #fieldmax
               item$ = GetGadgetText(\field(isubitem)\strgnr)
               SetGadgetItemText(#list_nr, iitem, item$, isubitem) 
            Next
            SetGadgetState(#list_nr, iitem)
            InputWindowClose()
            
      EndSelect
      
   EndWith  
EndProcedure

Procedure.i InputStringCheck(nr)
   With prgv
   
      Protected i$, nb
      Protected gadget = \field(nr)\strgnr
      Protected feldtyp = \field(nr)\typ
      
      Select feldtyp
         Case 48 To 57  ;eine Zahl ohne/mit Decimalstellen
            nb = feldtyp - 48
            i$ = GetGadgetText(gadget)
            ReplaceString(i$, "," , "." , #PB_String_InPlace)
            i$ = StrF(ValF(i$), nb)
            SetGadgetText(gadget, i$)
      EndSelect
      
   EndWith   
EndProcedure

Procedure.i InputCompute()
   With prgv      
      
      Protected j, p, rg$, opr$, op1$, op2$ 
      Protected nr, zielnr, erg.f, inp1.f, inp2.f
      Dim strg$(#fieldmax)
      
      ;hole Eingaben aus Maske
      For j = 1 To #fieldmax
         strg$(j) = GetGadgetText(\field(j)\strgnr)
      Next   
      ;#fieldmax Definitionen möglich
      For j = 1 To #fieldmax
         If \field(j)\rg       ;gibt es eine Formel ?
            ;find =
            rg$ = Trim(\field(j)\rg)                ;rg$ = "7 = #3 + #4"
            p = FindString(rg$, "=")               ;p = 3
            If p 
               ; = vorhanden
               zielnr = Val(Left(rg$, p-1))        ;zielnr = 7
               ;finde Operator und dessen Position 
               rg$ = Mid(rg$, p + 1)               ;rg$ = " #3 + #4"
               For p = 1 To Len(rg$)   
                  opr$ = Mid(rg$, p, 1)
                  Select opr$
                     Case "*", "+", "-", "/": Break    ;op = 43 ;entspricht +
                     Default: opr$ = ""                                 
                  EndSelect                        
               Next
               If opr$
                  ;Operator vorhanden an Position p, hole Operanden
                  op1$ = Trim(Left(rg$, p-1))      ;op1$ = "#3"
                  op2$ = Trim(Mid(rg$, p+1))       ;op2$ = "#4"
                  inp1 = ValF(op1$)
                  inp2 = ValF(op2$)
                  ;ist # vorhanden ?, wenn ja, inp1 bzw. inp2 wird Eingabe
                  If Left(op1$, 1) = "#"
                     nr = Val(Mid(op1$, 2))        ;nr = 3
                     inp1 = ValF(strg$(nr))        ;inp1 = Eingabe Feld 3; z.B. 100
                  EndIf
                  If Left(op2$, 1) = "#"
                     nr = Val(Mid(op2$, 2))        ;nr = 4
                     inp2 = ValF(strg$(nr))        ;inp2 = Eingabe Feld 4; z.B. 19
                  EndIf
                  If Right(op2$, 1) = "%"
                     inp2 = 1 + (inp2 / 100)
                     Select opr$
                        Case "+": opr$ = "*"
                        Case "-": opr$ = "/"
                        Default:  opr$ = ""
                     EndSelect
                  EndIf   
                  ;Rechnen
                  erg = 0
                  Select opr$
                     Case "*": erg = inp1 * inp2
                     Case "+": erg = inp1 + inp2
                     Case "-": erg = inp1 - inp2
                     Case "/": If inp2: erg = inp1 / inp2: EndIf
                  EndSelect      
                  strg$(zielnr) = StrF(erg)
                  If zielnr
                     SetGadgetText(\field(zielnr)\strgnr, strg$(zielnr))
                     InputStringCheck(zielnr)
                  EndIf   
               EndIf   
            EndIf
         EndIf   
      Next
      
   EndWith   
EndProcedure

Procedure.i SetColumnWidth(nr)
   
   Protected gadget = prgv\field(nr)\strgnr
   Protected feldbr = Val(GetGadgetText(gadget))
   
   prgv\field(nr)\br = feldbr
   SetGadgetItemAttribute(#list_nr, 0, #PB_ListIcon_ColumnWidth, feldbr, nr)
   
   If feldbr < 30: feldbr = 30: EndIf
   ResizeGadget(gadget, #PB_Ignore, #PB_Ignore, feldbr, #PB_Ignore)
      
EndProcedure

Procedure.i InputStringColor()
   With prgv   
      Protected nr = \lastfocus
      Protected color
      Protected gadget = \field(nr)\strgnr      
      
      Select \inputmode
         Case #menu_uni:  color = GetGadgetColor(gadget, #PB_Gadget_FrontColor)
         Case #menu_word: color = GetGadgetColor(gadget, #PB_Gadget_FrontColor)
         Case #menu_head: color = GetGadgetColor(gadget, #PB_Gadget_BackColor)
      EndSelect
      
      color = ColorRequester(color)
      
      If color > -1
         Select \inputmode
            Case #menu_uni
               If nr = 1
                  SetGadgetColor(gadget, #PB_Gadget_FrontColor, color)
               ElseIf nr = 2
                  SetGadgetColor(gadget, #PB_Gadget_FrontColor, color)
               EndIf   
            Case #menu_head: SetGadgetColor(gadget, #PB_Gadget_BackColor, color)
            Case #menu_word: SetGadgetColor(gadget, #PB_Gadget_FrontColor, color)
         EndSelect
      EndIf
   EndWith
EndProcedure

Procedure.i GetStringGadgetIndex(gadget)
   ;Prüft ob gadget ein EingabeStringGadget ist
   ;wenn ja, wird Index zurückgegeben (1-#fieldmax)
   
   Protected j, nr = 0
   
   For j = 1 To #fieldmax
      If prgv\field(j)\strgnr = gadget: nr = j: Break: EndIf   
   Next 
   
   ProcedureReturn nr
EndProcedure

Procedure.i MainIni(mode$ = "read")
   With prgv
      Protected j, iniok = OpenPreferences("miniadr.ini")
      
      If iniok = 0: CreatePreferences("miniadr.ini"): EndIf
      
      If mode$ = "write"
         WritePreferenceString ("Lastfile", \filename)
         WritePreferenceInteger ("Lastmax", \lastfilesmax)
         For j = 1 To \lastfilesmax
            WritePreferenceString ("Lastfile " + Str(j), \lastfiles(j))
         Next   
      Else
         \filename = ReadPreferenceString ("Lastfile", "Test.csv")
         \lastfilesmax = ReadPreferenceInteger ("Lastmax", 9)
         Dim \lastfiles(\lastfilesmax)
         For j = 1 To \lastfilesmax
            \lastfiles(j) = ReadPreferenceString ("Lastfile " + Str(j), "")
         Next   
      EndIf
   EndWith
   ClosePreferences()
EndProcedure

Procedure.i MainWindow()
   Protected j, flags
   
   LoadFont(0, "Arial", 9)
   SetGadgetFont(#PB_Default, FontID(0))
   
   With prgv
      flags = #PB_Window_SystemMenu|#PB_Window_Invisible|#PB_Window_MinimizeGadget|#PB_Window_SizeGadget
      OpenWindow(#window_main, 0, 0, 0, 0, "MiniAdr (PB 5.1  x86)", flags) 
      CreateStatusBar(0, WindowID(#window_main))
      AddStatusBarField(#PB_Ignore): AddStatusBarField(88)
      
      CreateMenu(0, WindowID(#window_main))
      MenuTitle("&Datei")
      MenuItem( #menu_load, "&Öffnen / Neu" + #TAB$ + "Strg+O")
      MenuItem( #menu_save,  "&Speichern" + #TAB$ + "Strg+S")
      MenuItem( #menu_save2, "Speichern &als...")
      MenuBar()
      MenuItem( #menu_print, "&Drucken")
      MenuBar()
      OpenSubMenu("&Letzte Dateien")
      For j = 1 To \lastfilesmax
         MenuItem( #lastfiles + j, Str(j) + ")  " + GetFilePart(\lastfiles(j)))
         DisableMenuItem(0, #lastfiles + j, 1)
         If Trim(\lastfiles(j))
            DisableMenuItem(0, #lastfiles + j, 0)
         EndIf 
      Next
      CloseSubMenu()
      MenuBar()
      MenuItem( #menu_progende, "&Beenden" + #TAB$ + "Alt+F4")
      MenuTitle("&Bearbeiten")
      MenuItem( #menu_new,  "&Neu" + #TAB$ + "Strg+N")
      MenuItem( #menu_edit, "&Ändern" + #TAB$ + "DblClick")
      MenuItem( #menu_kill, "&Löschen" + #TAB$ + "Entf")
      MenuBar()
      MenuItem( #menu_searchF4, "&Suchen" + #TAB$ + "Strg+F / F4")
      MenuItem( #menu_searchF5, "Suchen im &Feld" + #TAB$ + "F5")
      MenuItem( #menu_searchF3, "&Weitersuchen" + #TAB$ + "F3")
      MenuBar()
      MenuItem( #menu_strgc, "&Kopieren" + #TAB$ + "Strg+C")
      MenuItem( #menu_strgv, "&Einfügen" + #TAB$ + "Strg+V")
      MenuBar()
      MenuItem( #menu_mark,  "alle Daten &markieren" + #TAB$ + "Strg+A")
      MenuItem( #menu_nomark,"Markierung l&öschen")
      MenuItem( #menu_cdel,  "Spalteninhalt l&öschen") 
      MenuBar()
      MenuItem( #menu_add,  "&Addieren") 
      MenuItem( #menu_sort, "&Sortieren")
      MenuTitle("&Einstellungen")
      MenuItem( #menu_uni,   "&Allgemein")
      MenuItem( #menu_ftyp,  "&Feldtyp")
      MenuItem( #menu_align, "&Ausrichtung")
      MenuItem( #menu_head,  "&Spaltentitel + Farben")
      MenuItem( #menu_width, "Spalten&breite")
      MenuItem( #menu_calc,  "&Formeln definieren")
      MenuItem( #menu_popup, "&PopUp definieren")
      MenuItem( #menu_word,  "&Wörter definieren")
      MenuTitle("&Sonstiges")
      MenuItem( #menu_move,  "&Spalten verschieben")
      MenuBar()
      MenuItem( #menu_progdiv1, "&Google Maps")
      MenuItem( #menu_proginfo, "&Info")
      
      CreatePopupMenu(#popup_main)
      MenuItem( #menu_new,  "&Neu")
      MenuItem( #menu_edit, "&Ändern")
      MenuItem( #menu_kill, "&Löschen")
      MenuBar()
      MenuItem( #menu_add, "&Addieren") 
      
      CreatePopupMenu(#popup_input)
      For j = 1 To #fieldmax
         MenuItem( #input_item + j, "") 
      Next
      
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Control|#PB_Shortcut_O , #menu_load)
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Control|#PB_Shortcut_S , #menu_save)
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Alt    |#PB_Shortcut_F4, #menu_progende)
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Control|#PB_Shortcut_N , #menu_new)
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Control|#PB_Shortcut_A , #menu_mark)
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Control|#PB_Shortcut_C , #menu_strgc)
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Control|#PB_Shortcut_V , #menu_strgv)
      AddKeyboardShortcut(#window_main, #PB_Shortcut_Control|#PB_Shortcut_F , #menu_searchF4)
      AddKeyboardShortcut(#window_main,                      #PB_Shortcut_F5, #menu_searchF5)
      AddKeyboardShortcut(#window_main,                      #PB_Shortcut_F4, #menu_searchF4)
      AddKeyboardShortcut(#window_main,                      #PB_Shortcut_F3, #menu_searchF3)
      AddKeyboardShortcut(#window_main,                      #PB_Shortcut_F1, #menu_proghelp)
      AddKeyboardShortcut(#window_main,                      #PB_Shortcut_Delete, #menu_kill)
      
      HideWindow(#window_main, 0)
      ListFileLoad() ;Lastfile automatisch laden bei Programmstart
   EndWith
EndProcedure

Procedure.i MainEvent()   
   
   Protected j, k, nr, close = #False
   Protected color, dragdata, dragitem, dropitem
         
   With prgv
      Repeat
         Protected event  = WaitWindowEvent() ;was ist passiert 
         Protected window = EventWindow()     ;welches Fenster
         Protected gadget = EventGadget()     ;welches Gadget (Button, Liste etc)
         Protected eventtyp = EventType()     ;
         Protected menupoint = EventMenu()    ;welches Menuitem
         
         If window = #window_main         
            Select event          
               Case #PB_Event_MoveWindow
                  \main\x = WindowX(#window_main)
                  \main\y = WindowY(#window_main)
                  
               Case #PB_Event_SizeWindow
                  \main\br = WindowWidth(#window_main)
                  \main\hh = WindowHeight(#window_main)               
                  ResizeGadget(#list_nr, #PB_Ignore, #PB_Ignore, \main\br, \main\hh - StatusBarHeight(0) - MenuHeight())
                  
               Case #PB_Event_Gadget
                  If gadget = #list_nr
                     Select eventtyp  
                        Case #PB_EventType_LeftDoubleClick: InputEvaluate(#menu_edit)
                        Case #PB_EventType_RightClick:      DisplayPopupMenu(#popup_main, WindowID(#window_main))  
                        Case #PB_EventType_LeftClick:       StatusBarText(0, 1, "Satz: " + Str(GetGadgetState(#list_nr) + 1))
                        Case #PB_EventType_Change:          StatusBarText(0, 1, "Satz: " + Str(GetGadgetState(#list_nr) + 1))
                     EndSelect                        
                  EndIf
                  
               Case #PB_Event_Menu 
                  Select menupoint
                     Case #menu_01 To #menu_99: InputEvaluate(menupoint)
                     Case #menu_searchF4, #menu_searchF5: InputEvaluate(menupoint)
                     Case #menu_searchF3: DataSearchNext()
                     Case #menu_progende: ListFileSave(): close = #True
                     Case #menu_progdiv1: RunProgram("chrome.exe", #googlemap, "")
                     Case #menu_proghelp: OpenHelp("miniadr.chm", "Fenster.html")   
                     Case #menu_proginfo: MessageRequester("Information", #msg_version)
                     Case #lastfiles To #lastfiles + \lastfilesmax
                        \filename = \lastfiles(menupoint - #lastfiles)
                        ListFileLoad()
                  EndSelect                  
                  
               Case #PB_Event_CloseWindow: close = #True
            EndSelect
            
         ElseIf window = #window_input       
            Select event
               Case #RBUTTONDOWN_EVENT
                  nr = GetStringGadgetIndex(GetActiveGadget())
                  If nr
                     DisplayPopupMenu(#popup_input, WindowID(#window_input))
                  EndIf   
                  
               Case #PB_Event_MoveWindow
                  \input\x = WindowX(#window_input)
                  \input\y = WindowY(#window_input)
                  
               Case #PB_Event_Gadget, #PB_Event_Menu  ;Gadgetevent oder Menuevent vom Shortcut
                  Select gadget
                     Case #input_item To #input_item + #fieldmax  ;vom PopUp im InputWindow
                        SetGadgetText(GetActiveGadget(), GetMenuItemText(#popup_input, gadget))
                        
                     Case #input_go:    InputAnalyze()
                     Case #input_break: InputWindowClose()
                     Case #input_help:  OpenHelp("miniadr.chm", "Neu.html")   
                     Case #input_color: InputStringColor()
                     Case #input_clear: 
                        SetActiveGadget(\field(1)\strgnr)
                        For j = 1 To #fieldmax: SetGadgetText(\field(j)\strgnr, ""): Next
                                                
                     Case #input_mask1: If GetGadgetState(#input_mask1): \datemask = "%dd.%mm.%yy": EndIf
                     Case #input_mask2: If GetGadgetState(#input_mask2): \datemask = "%dd.%mm.%yyyy": EndIf
                     
                     Case #input_rcheck
                        If GetGadgetState(#input_rcheck)
                           DisableGadget(#input_replace, 0)
                           SetActiveGadget(#input_replace)
                        Else
                           DisableGadget(#input_replace, 1)
                        EndIf
                        
                     Case #input_text           
                        color = ColorRequester(\textcolor)
                        If color > -1: \textcolor = color: DataListColors(): EndIf
                        
                     Case #input_line: 
                        color = ColorRequester(\linecolor)
                        If color > -1: \linecolor = color: DataListColors(): EndIf
                        
                     Case #input_font: 
                        If FontRequester(\fontname, \fontsize, 0)
                           \fontname = SelectedFontName()
                           \fontsize = SelectedFontSize()
                           LoadFont(1, \fontname, \fontsize)
                           DataListColors()
                        EndIf                        
                        
                     Case #input_date
                        SetGadgetText(\field(\lastfocus)\strgnr, GetGadgetText(#input_date))
                        \lastdate = ParseDate(\datemask, GetGadgetText(#input_date))

                     Case #input_return
                        For j = 1 To #fieldmax 
                           If GetActiveGadget() = \field(j)\strgnr
                              j + 1
                              Select \inputmode
                                 Case #menu_add, #menu_new, #menu_edit, #menu_searchF5
                                    While GetGadgetItemAttribute(#list_nr, 0, #PB_ListIcon_ColumnWidth, j) = 0
                                       j + 1: If j > #fieldmax: j = 1: EndIf  
                                    Wend  
                              EndSelect
                              If j > #fieldmax: j = 1: EndIf  
                              SetActiveGadget(\field(j)\strgnr): Break
                           EndIf
                        Next  
                        
                     Case #input_box
                        If eventtyp = #PB_EventType_DragStart
                           dragitem = GetGadgetState(#input_box)
                           DragText(GetGadgetItemText(#input_box, dragitem))
                        EndIf
                        
                     Default  ;Prüfen ob ein Stringgadget und wenn ja, lastfocus zuweisen
                        Select eventtyp
                           Case #PB_EventType_LostFocus
                              nr = GetStringGadgetIndex(gadget)
                              If nr
                                 \lastfocus = nr
                                 Select \inputmode ;wird in InputEvaluate() gesetzt 
                                    Case #menu_edit, #menu_new
                                       InputStringCheck(nr)
                                       InputCompute()
                                    Case #menu_width
                                       SetColumnWidth(nr)
                                    Case #menu_align
                                       DataListAlign(nr)
                                 EndSelect                                 
                              EndIf
                        EndSelect
                  EndSelect                  
                  
               Case #PB_Event_GadgetDrop                  
                  If gadget = #input_box
                     dragdata = GetGadgetItemData(#input_box, dragitem)
                     RemoveGadgetItem(#input_box, dragitem)
                     dropitem = GetGadgetState(#input_box)
                     If dropitem = -1: dropitem = CountGadgetItems(#input_box): EndIf
                     AddGadgetItem(#input_box, dropitem, EventDropText())
                     SetGadgetItemData(#input_box, dropitem, dragdata)
                  EndIf   
                              
               Case #PB_Event_CloseWindow: InputWindowClose()                  
            EndSelect 
         EndIf         
      Until close = #True
   EndWith
EndProcedure

MainIni()
MainWindow()
MainEvent()

MainIni("write")
ListFileIni("write")

DataSection
   Data_DemoDaten:   ;Spalte null wird nur für Checkbox benutzt, optisch nicht vorhanden
   Data.s "leer,Vorname,Nachname,Plz/Ort,Strasse,Geb.Tag,Tel.,Handy,Info 1,Info 2,Info 3,Info 4" 
EndDataSection  
; IDE Options = PureBasic 5.10 (Windows - x86)
; CursorPosition = 1053
; FirstLine = 1064
; Folding = ------
; Markers = 586
; EnableXP
; Executable = miniadr.exe
; CompileSourceDirectory